/* Copyright (c) 2009 ActiveState Software Inc.
   See the file LICENSE.txt for licensing information. */

const CLASS_ID = Components.ID('{a4904f97-4a23-4d49-ac44-b3a48f0c3361}');
const CLASS_NAME = 'Komodo DBX Explorer JS Absolute Date Converter';
const CONTRACT_ID = '@activestate.com/KoDBX_JS_AbsoluteDateConverter;1';
const CATEGORY_NAME = 'komodo-DBX-DataConverters';

const Cc = Components.classes;
const Ci = Components.interfaces;
const Cr = Components.results;

function DBXAbsoluteJSDate() {
}

DBXAbsoluteJSDate.prototype = {
    'label': 'as absolute JS date',
    
    'supportedType':'integer',
    
    'convert': function(rawValue) {
        if (rawValue.length == 0) return "";
        try {
            return (new Date(parseInt(rawValue))).toString();
        } catch(ex) {
            dump("Can't convert " + rawValue + " into a date\n");
            return rawValue;
        }
    },

    QueryInterface: function(iid) {
        if(!iid.equals(Ci.koIDBXCellDataConverter) &&
           !iid.equals(Ci.nsISupports))
            throw Cr.NS_ERROR_NO_INTERFACE;
        return this;
    }
};

var DBXAbsoluteJSDateFactory = {
    createInstance: function(aOuter, iid) {
        if(aOuter != null)
            throw Cr.NS_ERROR_NO_AGGREGATION;
        return (new DBXAbsoluteJSDate()).QueryInterface(iid);
    }
};

var DBXAbsoluteJSDateModule = {
    registerSelf: function(compMgr, fileSpec, location, type) {
        dump("Registering '" + CONTRACT_ID + "' (absoluteJSDateConverter.js)\n");
        compMgr = compMgr.QueryInterface(Ci.nsIComponentRegistrar);
        compMgr.registerFactoryLocation(CLASS_ID, CLASS_NAME, CONTRACT_ID, fileSpec, location, type);
        var catMan = Cc['@mozilla.org/categorymanager;1'].
            getService(Ci.nsICategoryManager);
        catMan.addCategoryEntry(CATEGORY_NAME, CONTRACT_ID, "fred", true, true);
    },

    unregisterSelf: function(compMgr, fileSpec, location) {        
        compMgr = compMgr.QueryInterface(Ci.nsIComponentRegistrar);
        compMgr.unregisterFactoryLocation(CLASS_ID, location);
        var catMan = Cc['@mozilla.org/categorymanager;1'].
            getService(Ci.nsICategoryManager);
        catMan.deleteCategoryEntry(CATEGORY_NAME, CONTRACT_ID, true);
    },

    getClassObject: function(compMgr, cid, iid) {
        if (!iid.equals(Ci.nsIFactory))
            throw NS_ERROR_NOT_IMPLEMENTED;
        if (cid.equals(CLASS_ID))
            return DBXAbsoluteJSDateFactory;
        throw NS_ERROR_NO_INTERFACE;
    },

    canUnload: function(compMgr) {
        return true;
    }
};

function NSGetModule(compMgr, fileSpec) {
    return DBXAbsoluteJSDateModule;
}
